unit Sdemo01;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Sectime, Secbase, ExtCtrls, StdCtrls, Mask, Menus,
  RzPanel;

type
  TSecDemoForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    GroupBox1: TGroupBox;
    ReadCB: TCheckBox;
    WriteCB: TCheckBox;
    CreateCB: TCheckBox;
    DeleteCB: TCheckBox;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox4: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    GroupBox5: TGroupBox;
    Button7: TButton;
    Button8: TButton;
    Panel1: TPanel;
    Button10: TButton;
    ThSecBase1: TThSecBase;
    ThSecTime1: TThSecTime;
    MainMenu1: TMainMenu;
    Logon1: TMenuItem;
    IgnoreCase1: TMenuItem;
    Encryption1: TMenuItem;
    Internal1: TMenuItem;
    External1: TMenuItem;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    MaskEdit1: TMaskEdit;
    MaskEdit2: TMaskEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Button9: TButton;
    procedure Button10Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure IgnoreCase1Click(Sender: TObject);
    procedure Internal1Click(Sender: TObject);
    procedure External1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    procedure MyEncrypt(PlainText : string; var CipherText : string);
    procedure MyDecrypt(CipherText : string; var PlainText : string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SecDemoForm: TSecDemoForm;

implementation

{$R *.DFM}

procedure TSecDemoForm.Button10Click(Sender: TObject);
begin
  Close;
end;

procedure TSecDemoForm.Button1Click(Sender: TObject);
begin
  if ThSecBase1.Active then
  begin
    ThSecBase1.RegisterUserID(Edit1.Text,Edit2.Text);
  end
  else
    ShowMessage('Security Database not open yet!');
end;

procedure TSecDemoForm.FormShow(Sender: TObject);
begin
  ThSecBase1.ApplicationName := 'SecDemo';
  ThSecTime1.ApplicationName := 'SecDemo';
end;

procedure TSecDemoForm.Button2Click(Sender: TObject);

var
   GoodUser : boolean;

begin
  ThSecBase1.ValidateUserID(Edit1.Text,Edit2.Text,GoodUser);
  if Gooduser then
    Panel1.Caption := 'Valid user'
  else
    Panel1.Caption := 'Bad User!';
end;

procedure TSecDemoForm.Button3Click(Sender: TObject);

var
   DeleteOk : boolean;

begin
  ThSecBase1.DeleteUserID(Edit1.Text,Edit2.Text,DeleteOk);
  if DeleteOk then
    Panel1.Caption := 'Deletion sucessful'
  else
    Panel1.Caption := 'Deletion failed!';
end;

procedure TSecDemoForm.Button4Click(Sender: TObject);

var
   S : string[4];

begin
  S := '';
  if ReadCB.Checked then S[1] := 'R' else S[1] := ' ';
  if WriteCB.Checked then S[2] := 'W' else S[2] := ' ';
  if CreateCB.Checked then S[3] := 'C' else S[3] := ' ';
  if DeleteCB.Checked then S[4] := 'D' else S[4] := ' ';
  S[0] := #4;
  ThSecBase1.RegisterAccessData(Edit1.Text,Edit2.Text,S);
end;

procedure TSecDemoForm.Button5Click(Sender: TObject);

var
   S : string;

begin
  ThSecBase1.GetAccessData(Edit1.Text,Edit2.Text,S);
  ReadCB.Checked := (S[1] = 'R');
  WriteCB.Checked := (S[2] = 'W');
  CreateCB.Checked := (S[3] = 'C');
  DeleteCB.Checked := (S[4] = 'D');
end;

procedure TSecDemoForm.Button6Click(Sender: TObject);

var
   DeleteOk : boolean;

begin
  ThSecBase1.DeleteAccessData(Edit1.Text,Edit2.Text,DeleteOk);
  if DeleteOk then
  begin
    Panel1.Caption := 'Access data deleted';
    ReadCB.Checked := FALSE;
    WriteCB.Checked := FALSE;
    CreateCB.Checked := FALSE;
    DeleteCB.Checked := FALSE;
  end
  else
    Panel1.Caption := 'Access data NOT deleted!';
end;

procedure TSecDemoForm.Button7Click(Sender: TObject);

var
   i : integer;

begin
  with Panel2 do
  begin
    for i := 0 to ControlCount - 1 do
    begin
      if Controls[i] is TCheckBox then
      begin
        if (Controls[i] as TCheckBox).Checked then
        begin
          ThSecTime1.RegisterUserTimes(Edit1.Text,Edit2.Text,
                                       (Controls[i] as TCheckBox).Tag,
                                       StrToTime(MaskEdit1.Text),
                                       StrToTime(MaskEdit2.Text));
          (Controls[i] as TCheckBox).Checked := FALSE;
        end;
      end;
    end;
  end;
end;

procedure TSecDemoForm.IgnoreCase1Click(Sender: TObject);
begin
  ThSecBase1.CaseSensitive := not ThSecBase1.CaseSensitive;
  IgnoreCase1.Checked := not ThSecBase1.CaseSensitive;
end;

procedure TSecDemoForm.Internal1Click(Sender: TObject);
begin
  External1.Checked := FALSE;
  Internal1.Checked := TRUE;
  ThSecBase1.OnEncrypt := nil;
  ThSecBase1.OnDecrypt := nil;
  ThSecTime1.OnEncrypt := nil;
  ThSecTime1.OnDecrypt := nil;
end;

procedure TSecDemoForm.External1Click(Sender: TObject);
begin
  External1.Checked := TRUE;
  Internal1.Checked := FALSE;
  ThSecBase1.OnEncrypt := MyEncrypt;
  ThSecBase1.OnDecrypt := MyDecrypt;
  ThSecTime1.OnEncrypt := MyEncrypt;
  ThSecTime1.OnDecrypt := MyDecrypt;
end;

procedure TSecDemoForm.MyEncrypt(PlainText : string; var CipherText : string);

var
   S : string;
   i : integer;

begin
  for i := length(PlainText) downto 1 do CipherText[length(PlainText) - i + 1] := PlainText[i];
  CipherText[0] := char(length(PlainText));
end;

procedure TSecDemoForm.MyDecrypt(CipherText : string; var PlainText : string);

var
   S : string;
   i : integer;

begin
  for i := length(CipherText) downto 1 do PlainText[length(CipherText) - i + 1] := CipherText[i];
  PlainText[0] := char(length(CipherText));
end;

procedure TSecDemoForm.Button8Click(Sender: TObject);

var
   GoodTime : boolean;

begin
  ThSecTime1.ValidateUserTimes(Edit1.Text,Edit2.Text,GoodTime);
  if GoodTime then
    Panel1.Caption := 'Valid Time'
  else
    Panel1.Caption := 'Invalid Time!';
end;

procedure TSecDemoForm.Button9Click(Sender: TObject);

var
   i : integer;
   DelOk : boolean;

begin
  with Panel2 do
  begin
    for i := 0 to ControlCount - 1 do
    begin
      if Controls[i] is TCheckBox then
      begin
        if (Controls[i] as TCheckBox).Checked then
        begin
          ThSecTime1.DeleteUserTimes(Edit1.Text,Edit2.Text,
                                       (Controls[i] as TCheckBox).Tag,DelOk);
          if DelOk then
          begin
            Panel1.Caption := 'Delete successful';
            (Controls[i] as TCheckBox).Checked := FALSE;
          end
          else
            Panel1.Caption := 'Delete Failed!';
        end;
      end;
    end;
  end;
end;

end.
